title MSDOS 2.00 Function Library for Lattice C
;
;........................................
;.					.
;.	DOS 2.00 Functions for		.
;.	       Lattice			.
;.					.
;.	T. Jennings 23 June 83		.
;.	  created 13 Sept 82		.
;.					.
;........................................
;
;MSDOS 2.00 support for Lattice. These will NOT
;work for version 1.xx of DOS. All support full
;paths. The function names are the same as the
;standard library names with "_x" prepended, to
;accomodate my file system nameing heirarchy.
;
;NO a function returning a pointer to a function, and this
function returns a pointer to an int.
Thus you could do things like:

int *(*func2)(); /*pointer to a function returning a pointer to int*/
int *x;
.
.
.
func2 = func1();
x = (func2)();
.
.
etc.

Cheers

        Scott Pace, ...!philabs!micomvax!othervax!scott

(I hope I got all that right!!!)
(Mail) End of article 4918 (of 4956)--what next? [npq] 

Article 4920 (36 more) in net.lang.c:
From: tim@callan.UUCP (Tim Smith)
Newsgroups: net.lang.c,net.micro.mac
Subject: Re: help with sizeof() in HIPPO-C
Message-ID: <1088@callan.UUCP>
Date: 27 Aug 85 00:22:46 GMT
Date-Received: 31 Aug 85 06:00:52 GMT
References: <1518@islenet.UUCP>
Distribution: net
Organization: Callan Data Systems, Westlake Village, CA
Lines: 27

--MORE--(41%)> Just discovered that there does not seem to be a sizeof() function
> in Hippo C level I or II.  This would sure be useful for passing

Level I was written in Pasadena, and when I was bored, I would go over
and hassle them about things I thought they were doing wrong.  I don't think
I would have missed a lack of sizeof.  Also, we once ran a set of C progrs
meant to test out pcc through Hippo level I, and there must have been
a sizeof in there somewhere!  ( no - I can't tell anyone where to get
the set of test programs. ).

Anyway, try all of the following, since I am not sure how they handle
builtin functions like sizeof -- they may have fucked up the parsing:

        sizeof x ;              /* where x is a variable */
        sizeof(x) ;
        sizeof( x ) ;
        sizeof (x) ;
        sizeof ( x ) ;
        sizeof(int) ;
        sizeof( int ) ;
        sizeof (int) ;
        sizeof ( int ) ;

If none of these work, give them a call.
-- 
                                        Tim Smith
                                ihnp4!{cithep,wlbr!callan}!tim
(Mail) End of article 4920 (of 4956)--what next? [npq] 


Article 4922 (34 more) in net.lang.c:
From: franka@mmintl.UUCP (Frank Adams)
Subject: Re: Cryptic C (YES/NO vs. TRUE/FALSE + other thoughts)
Message-ID: <625@mmintl.UUCP>
Date: 27 Aug 85 03:01:24 GMT
Date-Received: 31 Aug 85 09:52:38 GMT
References: <2913@ncsu.UUCP> <709@brl-tgr.ARPA> <5884@utzoo.UUCP> <989@gatech.CSNET>
Reply-To: franka@mmintl.UUCP (Frank Adams)
Organization: Multimate International, E. Hartford, CT
Lines: 33
Summary: Aggregates are even better

--MORE--(42%)
In article <989@gatech.CSNET> arnold@gatech.CSNET (Arnold Robbins) writes:
>
>Well, this can get carried too far.  I have worked with code based on
>Software Tools stuff that looks like
>
>       dowrite (file, YES, NO, NO, YES);
>
>Now, can you tell what the heck it is doing? Especially when the code for
>dowrite() is 700 lines down in another file? I've often thought that a style
>like
>
>#define FORCEWRITE     1
>#define NOFORCE                0
>
>#define APPEND         1
>#define NOAPPEND       0
>
>       dowrite (file, FORCEWRITE, APPEND, ....);       /* call */
>
>
>is much clearer than the first style.  This is the kind of thing, if anything,
>that "enums" would be most useful for (no flames about how poorly enums are
>implemented. I'm talking conceptually here.).

The problem with your solution is I can just easily write

        dowrite(file, APPEND, NOFORCE, ...)

and will have a terrible time finding the error.  This is where Ada wins:

        dowrite(file, append=>true, force=>false, ...)

is clear, simple, and error-resistant.
(Mail) End of article 4922 (of 4956)--what next? [npq] 

Article 4923 (33 more) in net.lang.c:
From: stern@bnl.UUCP (eric)
Subject: Re: VAX VMS C / UNIX C Compatibility -- Need Info
Message-ID: <150@bnl.UUCP>
Date: 27 Aug 85 16:50:32 GMT
Date-Received: 31 Aug 85 09:53:03 GMT
References: <488@rdin.UUCP> <249@watmum.UUCP> <545@osu-eddie.UUCP>
Organization: Brookhaven National Lab. Upton, N.Y.
Lines: 19

--MORE--(41%)> > VMS is very record-ish, while stream i/o is the unix thing. Unfortunately,
> > port didn't work because we didn't really spend the effort required to do
> > the QIO's required to fake stream i/o on VMS. 
> 

A year or TE: You cannot mix these calls with the 
;Lattice library calls: i.e. open with _xopen()
;and write with open(). You must use ALL or
;NONE.
;
;These functions all use the DOS buffers. 
;
;Detailed info is given in the title block for
;each function. A quick description follows.
;
;handle= _xopen(pathname,access);
;int handle,access;
;char *pathname;
;
;	Open a file. handle returns either 
;the DOS handle, or -1 if error (file not 
;found). Access is: 0 == read only, 1 == write
;only, 2 == read/write.
;
;handle= _xcreate(pathname,access);
;
;	Create a new file, delete any existing
;copy. Access is not used: use 0. Returns the
;handle or -1 if error.
;
;v= _xread(handle,buffer,count);
;v= _xwrite(handle,buffer,count);
;int v,handle,count;
;char *buffer;
;
;	File read or write to an opened or
;created file. reads or writes 'count' bytes
;to the file 'handle', to or from 'buffer'.
;Returns the number of bytes processed: equal
;to 'count' if sucessful.
;
;error= _xclose(handle)
;int error;
;
;	Close an open file. Returns -1 if 
;error. Any buffers are flushed at this point.
;
;_xdelete(pathname);
;
;	Remove the file from the file
;system.
;
;fsize= _fsize(pathname);
;long fsize;
;
;	Returns the size of the file in bytes.
;Returns 0 if no file. Do NOT call inbetween
;calls to _xfind().
;
;found= _xfind(pathname,filename,&fsize,attrib,flag);
;int found,flag,attrib;
;char *pathname,filename[14];
;long fsize;
;
;Search for the specified pathname. flag should
;be 0 for the first call, non-zero for all
;subsequent calls. _xfind() returns true if a
;match was found, and the found file is 
;returned in filename[], in ASCIZ format.
;Attrib is the DOS attributes to match; I
;will not describe that mess here. _xfind()
;returns the size of the file in fsize. (Don't
;forget to pass the address of fsize.)
; For example:
;
;int i;
;char filename[14];
;long fsize;
;
;	i= 0;
;	while (_xfind("\\bin\\*.*",filename,&fsize,0,i)) {
;		printf("File: %14s Size: %lu\n",filename,fsize);
;		++i;
;	}
;	printf("%u matching files.\n",i);
;
;Prints the names of all matching disk files. 
;Any other calls (except_fsize()) can be made
;in between calls to _xfind().
;
dgroup group data
pgroup group prog

prog segment byte public 'prog'

public	_xopen,_xcreate,_xclose
public	_xread,_xwrite
public	_xfind
public	_fsize
public 	_xdelete
assume cs:pgroup,ds:dgroup
;;
;;	handle= _xcreate(name,access)
;;	handle= _xopen(name,access)
;;
;;	int handle;		-1 if error,
;;	int access;		0=r, 1=w, 2=r/w
;;	char *name;		null terminated
;;
;;Open and create functions. The name is a null
;;terminated string. The access byte is passed
;;directly to DOS. All errors are translated to
;;a -1 return value.
;;
_xopen proc near
	mov	ah,61
	jmp	sho